//EXAMPLE3 JOB  'JAY MOSELEY',CLASS=A,MSGLEVEL=(1,1),REGION=512K
//* ***************************************************************** *
//* * THIS VERSION OF EXAMPLE PROGRAM 3 WILL ONLY RUN UNDER MVS!    * *
//* ***************************************************************** *
//DEFINE   EXEC PGM=IDCAMS,REGION=4096K
//SYSPRINT DD  SYSOUT=A                                                 00030000
//DD1      DD  DSN=STUDENT.KSDS,
//             DISP=SHR,UNIT=3350,VOL=SER=PUB001
//SYSIN    DD  *                                                        00070000

  /* DELETE KSDS CLUSTER                                    */

  DELETE STUDENT.KSDS                                  -
         CLUSTER FILE(DD1) PURGE

  /* DEFINE KSDS CLUSTER                                    */

  DEFINE CLUSTER (                                      -
         NAME ( STUDENT.KSDS                          ) -
         VOLUMES ( PUB001 )                             -
         RECORDSIZE ( 250 250 ) /* AVG MAX */           -
         RECORDS ( 500 100 )                            -
         FREESPACE ( 25 30 )    /* CI CA */             -
         KEYS ( 7 1 )           /* LEN POS */           -
         INDEXED                                        -
                  )                                     -
         DATA (                                         -
         NAME ( STUDENT.KSDS.DATA                     ) -
              )                                         -
         INDEX (                                        -
         NAME ( STUDENT.KSDS.INDEX                    ) -
               )
/*                                                                      00090000
//RPGCLG   EXEC RPGECLG,COND.LKED=(9,LT,RPG)
//RPG.SYSUT3 DD UNIT=SYSDA
//RPG.SYSUT2 DD UNIT=SYSDA
//RPG.SYSUT1 DD UNIT=SYSDA
//RPG.SYSGO DD  UNIT=SYSDA
//RPG.SYSIN DD  *
     H
     H*
     H*  CREATE ISAM STUDENT MASTER FILE FROM CARDS
     H*
     FINCARDS IPE F  80  80            READ40
     FSTMASTR O   F 250 250  7KI     2 DISK14       S
     FREPORT  O   F 132 132     OF    LPRINTER
     LREPORT    101 6012
     IINCARDS AA  01   1 CA
     I                                        3   9 IDENTA
     I                                       10  44 NAME
     I                                       45  79 ADDR1
     I        BB  02   1 CB
     I                                        3   9 IDENTB
     I                                       10  44 ADDR2
     I                                       45  45 GENDER
     I                                       46  550PHONE
     I                                       56  630BDATE
     I                                       64  66 MAJOR
     C*
     C* DURING FIRST CYCLE (1P), SETUP CONSTANT FIELDS
     C* TO INITIALIZE MASTER FIELDS NOT PROVIDED ON
     C* INPUT CARDS
     C*
     C   1P                Z-ADD0         Z5      52
     C   1P                MOVE ' '       B40    40
     C*
     C* COUNT INPUT CARDS OF EACH TYPE FOR REPORT TOTALS
     C*
     C   01      CACNT     ADD  1         CACNT   30
     C   02      CBCNT     ADD  1         CBCNT   30
     C*
     C* FOR "A" CARD, IF LAST CARD READ NOT "A" CARD,
     C* SETON INDICATOR 20
     C*
     C   01                SETOF                     20
     C   01      '       ' COMP PREVA                    20
     C*
     C* FOR "A" CARD, SAVE STUDENT ID IN PREVA
     C*
     C   01                MOVE IDENTA    PREVA   7
     C*
     C* FOR "B" CARD, IF MATCHES PREVIOUS "A" CARD,
     C* SETON INDICATOR 21
     C*
     C   02                SETOF                     2021
     C   02      IDENTA    COMP PREVA                    21
     C*
     C* IF THIS "B" MATCHES PREVIOUS "A" AND THE STUDENT
     C* ID IS GREATER THAN LAST STUDENT ID ADDED,
     C* SETON INDICATOR 20
     C*
     C   02 21   IDENTB    COMP KEYH                 20
     C   02 20             MOVE IDENTB    KEYH    7
     C*
     C* CARD SET IS COMPLETE, COUNT AS ADDED RECORD
     C*
     C   02 20   ADDCNT    ADD  1         ADDCNT  30
     C*
     C* WHEN CARD "B" IS READ, RESET ID FROM PREVIOUS CARD "A"
     C*
     C   02                MOVE '       ' PREVA
     OSTMASTR D        02 20
     O                         B40      250
     O                         Z5       210P
     O                         Z5       207P
     O                                  204 '000000'
     O                         Z5       198P
     O                                  195 '000000'
     O                         Z5       189P
     O                                  186 '000000'
     O                         Z5       180P
     O                                  177 '000000'
     O                         Z5       171P
     O                                  168 '000000'
     O                         Z5       162P
     O                                  159 '000000'
     O                         Z5       153P
     O                                  150 '000000'
     O                         Z5       144P
     O                                  141 '000000'
     O                         MAJOR    135
     O                         BDATE    132
     O                         PHONE    124
     O                         GENDER   114
     O                         ADDR2    113
     O                         ADDR1     78
     O                         NAME      43
     O                         IDENTB     8
     O                                    1 'A'
     OREPORT  H  201   1P
     O       OR        OF
     O                                   23 'CREATION'
     O                                   15 'STUDENT MASTER '
     O        D  1     02 20
     O                         NAME      52
     O                                   17 'ADDED: '
     O                         IDENTB     9
     O        D  1     02N20
     O                                   51 'B CARD WITHOUT A CARD'
     O                         IDENTB     9
     O        D  1     01N20
     O                                   51 'A CARD WITHOUT B CARD'
     O                         IDENTA     9
     O        T 31     LR
     O                                   20 '"A" CARDS READ'
     O                         CACNT Z    5
     O        T  1     LR
     O                                   20 '"B" CARDS READ'
     O                         CBCNT Z    5
     O        T  1     LR
     O                                   19 'RECORDS ADDED'
     O                         ADDCNTZ    5
     O        T 31     LR
     O                                   22 '*** END OF REPORT ***'
/*
//GO.REPORT DD SYSOUT=A
//GO.INCARDS DD  *
A 0025654SAMANTHA D. LABROIE                3023 SEASIDE AVENUE
B 0025654WEST PALM BEACH      FL 33406      F561566137719390618BA
A 0034591NELSON E. CHILDRESS                6323 ROSA LINDA STREET
B 0034591FALLS VILLAGE        CT 06031      M203853895819140402MAT
B 0038851ROANOAK              VA 24014      F540329282719440430PHS
A 0040736ELIZABETH W. GLOVER                6117 MILLBROOK STREET
B 0040736ROSWELL              GA 30075      F404544606019540907PHS
A 0043415ROLAND D. JOHNSON                  185 VAN ZANDT PLACE
B 0043415OKLAHOMA CITY        OK 73120      M405866617619281230CSC
A 0054796MIKE T. RICHARDS                   258 WINDWOOD ROAD
B 0054796ST. CLAIR            MI 48048      M313936088619460209CHE
B 0063296ROCHESTER            NY 03840      M315131844019490831ART
A 0072697HANNAH E. NORTON                   268 GRANT COURT
B 0072697KEARNEY              NE 68848      F402970934019370104EDU
A 0099174CINDY D. MCQUEEN                   8589 PECAN VALLEY STREET
B 0099174BALDWIN              MO 63022      F417845642619350331ENG
A 0118376THELMA B. SCHWAB                   9023 RIO VISTA STREET
A 0120756SARAH V. MCKENZIE                  4292 SEABREEZE COURT
B 0120756BOSTON               MA 02130      F617327380219510131EDU
A 0136491LAURIE B. REED                     3022 GARRETT PLACE
B 0136491AUSTIN               TX 78759      F512217767119120731PHS
A 0139894SAMANTHA I. HASTINGS               8541 MICHIGAN STREET
B 0139894SAN ANTONIO          TX 78216      F210749116219141125ART
A 0141670RICHARD A. GARLAND                 1933 MILL MOUNTAIN AVENUE
B 0141670SAN ANTONIO          TX 78216      M210331468419500609MAT
A 0152570HEATHER J. HORTON                  1774 MILLBROOK AVENUE
B 0152570FALLS VILLAGE        CT 06031      F203830803719700429CHE
A 0166305HEATHER J. MORENO                  637 ELLIS AVENUE
B 0166305RIVERSIDE            NJ 08370      F201936049319120731CHE
A 0176560ARNOLD O. HILLFORD                 6786 MEADOW STREET
B 0176560FALLS VILLAGE        CT 06031      M203795493619510131EDU
A 0190433CINDY E. NOELKE                    936 WINDTREE CIRCLE
B 0190433ANCHORAGE            AK 99508      F907101171419250623BIO
A 0194091DEBRA A. NEWTON                    6701 SUN MEADOW CIRCLE
B 0194091ANCHORAGE            AK 99508      F907726505319260318BA
A 0202663RICHARD O. HAMMOND                 2300 EDMUND CIRCLE
B 0202663HATTERAS             NC 27943      M919395398819130714ENG
A 0208198JACK D. MEEHAN                     7174 COBBS STREET
B 0208198OKLAHOMA CITY        OK 73120      M405683178719250815BA
A 0223563KATHRYN I. SCHWAB                  788 TWILIGHT ROAD
B 0223563KNOXVILLE            TN 37932      F901211505519460321CSC
A 0243012DIANE G. NOELKE                    5460 ELLIS AVENUE
B 0243012ANCHORAGE            AK 99508      F907844097419250623ART
A 0243815JIM N. MEEHAN                      892 SAND CREEK STREET
B 0243815BOISE                ID 83714      M208976331319440430PHS
A 0244106JACOB T. WINSTON                   7563 LIVE OAK STREET
B 0244106PHOENIX              AZ 85040      M602605906819281230ART
A 0285887EVERETT K. VANACKER                160 COLISEUM STREET
B 0285887SALT LAKE CITY       UT 84109      M801325183219350216CSC
A 0289051ANN H. BURNETT                     644 PARKER ROAD
B 0289051NEWPORT              RI 02840      F401839617119310904ENG
A 0291088ERNIE S. CHILDRESS                 3921 HANOVER STREET
B 0291088GREENVILLE           KY 42345      M602796366419471208EDU
A 0297566LARRY H. ALAN                      538 VILLA PARK AVENUE
B 0297566ST. CLAIR            MI 48048      M313723913919370905PE
A 0306654CALVIN B. RODGERS                  916 DESERT STREET
B 0306654FREMONT              CA 94538      M909773572919440520EDU
A 0318326LOUISE L. PARKER                   345 ATOLL STREET
B 0318326MINNEAPOLIS          MN 55437      F320271396519450204ART
A 0322868JANET F. NORRIS                    8817 LINCOLN BLVD
B 0322868BALDWIN              MO 63022      F417837136719180129CSC
A 0331623LUCY B. LANDERS                    9830 LIVE OAK BLVD
B 0331623FALLS VILLAGE        CT 06031      F203814999019250706CSC
A 0342751MARILYN W. JACOBY                  440 TWILIGHT STREET
B 0342751ALBUQUERQUE          NM 87108      F505688491019120731BA
A 0356637KAREN A. TUCKER                    2123 MILL MOUNTAIN BLVD
B 0356637ALBUQUERQUE          NM 87108      F505343053419390812MAT
A 0358768EVERETT R. PARRISH                 773 SIERRA VISTA BLVD
B 0358768SAN ANGELO           TX 76903      M915629380319141125ENG
A 0365482BETTY J. NEWTON                    2349 SEASIDE AVENUE
B 0365482SPARKS               NV 89431      F702865109619430608PHS
A 0366869EVELYN C. LANDERS                  2078 COLISEUM STREET
B 0366869BATON ROUGE          LA 70805      F318315600319440913CSC
A 0371633HELEN C. BENSON                    6969 MILL MOUNTAIN AVENUE
B 0371633DENTON               TX 76201      F817156393019680208PHS
A 0395489JACK S. HASTINGS                   8646 BALBOA STREET
B 0395489KANSAS CITY          MO 64118      M816792085919330314BIO
A 0405326CALVIN B. BRYANT                   536 HORSESHOE CIRCLE
B 0405326PHOENIX              AZ 85040      M602644000219430322BA
A 0427620TED R. MCKAY                       777 STRAWBERRY STREET
B 0427620RIVERSIDE            NJ 08370      M201809262519440520BA
A 0464796LAURIE N. TEASDALE                 396 ROSEWOOD STREET
B 0464796SAN ANTONIO          TX 78216      F210353006819161104CHE
A 0466722TAMMY T. NEWBURY                   8255 ROSEWOOD STREET
B 0466722ALBUQUERQUE          NM 87108      F505223881919390210CSC
A 0467007LARRY W. WINSTON                   602 TAPPAN STREET
B 0467007ATLANTA              GA 30305      M404244055319440430ART
A 0478623KIMBERLY G. GLOVER                 7677 LIVE OAK PLACE
B 0478623EUGENE               OR 97402      F541951445219460209MAT
A 0487226CHARLES K. HALL                    264 LAKEFRONT BLVD
B 0487226PHOENIX              AZ 85040      M602491155719620619EDU
A 0552068TED D. MULL                        323 WESTRIDGE ROAD
B 0552068LAGO VISTA           TX 78645      M512723905419221103BIO
A 0555590CAITLIN I. MEEHAN                  211 GUADLAUPE ROAD
B 0555590DENTON               TX 76201      F817806895919161104MAT
A 0560806HOWARD B. HODGES                   9889 INDUSTRIAL STREET
B 0560806ROCHESTER            NY 03840      M315836788019230810MAT
A 0566030CYBIL M. CONLEY                    5786 FOREST ROAD
B 0566030TAMPA                FL 33619      F813618619619320109PHS
A 0574793WANDA I. LARUE                     730 LIVE OAK CIRCLE
B 0574793CHARLOTTE            NC 28262      F704713043819410730CSC
A 0575617RUSSELL S. ERICKSON                548 FOREST AVENUE
B 0575617LA HABRA             CA 90631      M530108677919440520PE
A 0591132ERNIE E. GLASSMAN                  908 WESTRIDGE ROAD
B 0591132SAN ANGELO           TX 76903      M915981938019500609PE
A 0597225JIM O. AUSTIN                      355 KOBERLIN STREET
B 0597225GRAND RAPIDS         MN 55745      M218152100919220707BIO
A 0610936BOB A. SCHAEFER                    9049 SAND CREEK AVENUE
B 0610936PONCA CITY           OK 74603      M405189815719411003PHS
A 0612082MARGUERITE K. HASTINGS             345 BIENVILLE STREET
B 0612082ENGLEWOOD            CO 80112      F303463490819370104MAT
A 0612533RONALD I. HODGES                   9037 DESERT STREET
B 0612533KNOXVILLE            TN 37932      M901757278019310130CHE
A 0625143ARNOLD W. PARRISH                  6374 BRIARGLEN STREET
B 0625143DES PLAINES          IL 60018      M708562985119190206PE
A 0637591EVERETT H. BURNETT                 230 HANOVER STREET
B 0637591ROANOAK              VA 24014      M540122530519230810EDU
A 0643686PETER H. HASTINGS                  186 TAPPAN PLACE
B 0643686CHICAGO              IL 60611      M708282975719300531BA
A 0647893SAMANTHA B. HORTON                 1389 ROBINHOOD STREET
B 0647893JUNEAU               AK 99801      F907279340519251124BA
A 0687119LARRY V. WEAVER                    3903 BRIGHT STREET
B 0687119DOWNEY               CA 90302      M213711623619070929CHE
A 0687191CALVIN D. LABROIE                  841 SHERIDAN CIRCLE
B 0687191TAMPA                FL 33619      M813244295519280523PHS
A 0700304MARGUERITE N. HILLFORD             1769 WILSHIRE ROAD
B 0700304MIDLAND              TX 79702      F915209076519220416MAT
A 0713816TED A. FRANKLIN                    2964 SHERWOOD STREET
B 0713816PALM DESERT          CA 92211      M760165410419560709PE
A 0717587DANIEL R. MCKAY                    869 MILL MOUNTAIN ROAD
B 0717587TULSA                OK 74135      M918619489819180129BA
A 0722338WILLIAM K. HALL                    318 WESTRIDGE ROAD
B 0722338DENTON               TX 76201      M817568166619370706PHS
A 0728987SHARON T. YAEGER                   1323 VILLA PARK STREET
B 0728987DETROIT              MI 48205      F313594043719350826CHE
A 0740764ZELDA E. MCKENZIE                  1351 BUCKLEY STREET
B 0740764KANSAS CITY          MO 64118      F816436224919340217PE
A 0748067EVERETT I. RAMSEY                  534 INDUSTRIAL AVENUE
B 0748067PHOENIX              AZ 85040      M602939268219161104PE
A 0748758JACOB K. PARKER                    1510 SUNSET COURT
B 0748758SANTA FE             NM 87501      M505655987619310130BIO
A 0755610TAMMY L. NORRIS                    658 BRIARGLEN ROAD
B 0755610WASHINGTON           DC 20009      F202974608819440430EDU
A 0757139JOAN L. GARLAND                    9268 HEDGEWOOD COURT
B 0757139SPRING               TX 77373      F281285951019540907BIO
A 0766116RONALD M. GARLAND                  514 HILLSIDE ROAD
B 0766116OKLAHOMA CITY        OK 73120      M405948446719330314ART
A 0778839JOHN J. JACKSON                    932 BURWELL CIRCLE
B 0778839BRIDGEPORT           CT 06605      M860856694319161209BIO
A 0790544THELMA I. RODGERS                  8625 HILLSIDE PLACE
B 0790544SAN ANGELO           TX 76903      F915601388519241202BIO
A 0791357LOUISE W. HARMON                   7886 ATOLL STREET
B 0791357JUNEAU               AK 99801      F907779756519220622BA
A 0793297LARRY C. GERBLICK                  455 KINGS RIDGE ROAD
B 0793297SAN FRANCISCO        CA 94105      M415385026619540907EDU
A 0793617CLIFF N. WHITE                     8002 BRIARGLEN CIRCLE
B 0793617ANNAPOLIS            MD 21402      M410844307519320109BIO
A 0809327RUTH H. FRANKLIN                   347 WHITE SANDY COURT
B 0809327PRESCOTT             AZ 86314      F520220720519471208MAT
A 0822928DAWN I. FITZGERALD                 661 RIVER OAKS BLVD
B 0822928ST. CLAIR            MI 48048      F313803464919540907CSC
A 0825790LOUIS E. AUSTIN                    906 CARBONDALE COURT
B 0825790KNOXVILLE            TN 37932      M901721385519240916PHS
A 0836832BRENDA F. TUCKER                   605 ROSEWOOD CIRCLE
B 0836832ALBUQUERQUE          NM 87108      F505822369719130115CSC
A 0853058CINDY O. MCKAY                     984 PARKWAY STREET
B 0853058BINGHAMTON           NY 11704      F315181899019230526MAT
A 0853466CLARA T. MORENO                    3204 CARBONDALE PLACE
B 0853466TULSA                OK 74135      F918286516619351221CSC
A 0857212VIRGINIA A. PETERSON               7414 MEADOW CIRCLE
B 0857212DENVER               CO 80256      F303762015319250706MAT
A 0858241PATTY S. VANACKER                  205 STRAWBERRY ROAD
B 0858241ROANOAK              VA 24014      F540594920619081120EDU
A 0881002ROLAND F. BRYANT                   527 HILLSIDE STREET
B 0881002DENTON               TX 76201      M817122555619411003MAT
A 0888561ERNIE A. HALL                      369 GUADLAUPE CIRCLE
B 0888561LOUISVILLE           KY 40207      M502712639719580615CHE
A 0892174BETTY P. DRAKE                     7925 BRIARGLEN CIRCLE
B 0892174ALBANY               NY 12206      F518436247719220622CSC
A 0928546JOSEPH R. SMITH                    7615 ATOLL PLACE
B 0928546TAMPA                FL 33619      M813954200419750222CHE
A 0935786ROBERT I. BARBER                   925 PARKER BLVD
B 0935786DENTON               TX 76201      M817842196219510131PHS
A 0965296YOLANDA C. LARUE                   818 MILL MOUNTAIN BLVD
B 0965296VALPARAISO           IN 46383      F765813447819270301BIO
A 0967407JANET V. TEASDALE                  456 HEDGEWOOD CIRCLE
B 0967407CHICAGO              IL 60611      F708976195319270301PHS
A 0967791LUCY I. POWERS                     1146 BUCKLEY ROAD
B 0967791ALBUQUERQUE          NM 87108      F505107437819491128EDU
A 0968791BEVERLY L. RICHARDS                8040 SHORE CIRCLE
B 0968791TULSA                OK 74135      F918839057119450204PHS
A 0970626JILL K. JENNINGS                   6941 SOUTHLAND STREET
B 0970626COLUMBUS             GA 31997      F912212539519081120MAT
A 0979347TOM T. COOK                        829 PARSON CIRCLE
B 0979347MISSOULA             MT 59802      M406243461319470906EDU
A 0982436JOSEPH H. THATCHER                 246 WILSHIRE STREET
B 0982436JUNEAU               AK 99801      M907303834119310904EDU
/*
//GO.SYSUDUMP DD SYSOUT=A
//GO.STMASTR DD DSN=STUDENT.KSDS,DISP=MOD,AMP=(AMORG,'RECFM=F')
//PRINT    EXEC PGM=IDCAMS,REGION=4096K
//SYSPRINT DD  SYSOUT=A                                                 00030000
//DD1      DD  DSN=STUDENT.KSDS,DISP=SHR
//SYSIN    DD  *                                                        00070000
  PRINT INFILE(DD1) DUMP
/*                                                                      00090000
//                                                                      00100000
